///////////////////////////////////////////////////////////////////////////////
//Standard-Map mit Möglichkeit zum zoomen und einzelne Trajektorien zu erzeugen
//Gewählte Darstellung: Polarkoordinaten  SxR
//Es wurden so weit wie möglich double Attribute verwendet, um bei relativ 
//großer Anzahl der Iterationen noch rationale Rotationszahlen als 
//diskontinuierlich sehen zu können
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: 
float aU = 0;   float aO = 2*PI; //Winkelbereich
float rU = 0  ; float rO = 10; //Radiusbereich
double A,B; //Differenzen in x und y zum aktuellen Mittelpunkt
double  aUNeu, aONeu, rUNeu, rONeu,aAlt, rAlt, aNeu, rNeu;
double  aH, rH; //Startpunkte in Polarkoordinaten
PFont font;
double w = 800; double h = 800; 
double dw =0; double dh =0;//Verschiebung des Mittelpunktes in Pixel (kartesisch!)
float wx,hy; //aktueller Mittelpunkt in Pixel (kartesisch!)
double aK, rK; //Poloar-Koordinaten der Punkte
int n, i, l, L, M; //Erläuterung im setup()
int f; //für die Farbe
float faktor; //für Vergrößerung
//float faktorE; //Vergrößerung Mannigfaltigkeit
double R,r,phi; //Polarkoordinaten
double K;
double rE,aE;
float rEK, aEK;
int AnzahlMFPunkte, AnzahlIterationen ;
float aVektor,rVektor;
boolean zeichnen, trajektZeichnen, schonTransparent, ersterPunkt;
PImage bild;
ArrayList<PVector> punkte0 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der stabilen MF
ArrayList<PVector> punkte1 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der stabilen MF
ArrayList<PVector> punkte2 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der instabilen MF
ArrayList<PVector> punkte3 = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte der instabilen MF
///////////////////////////////////////////////////////////////////////////

void setup(){ 
  size(800, 800);
  background(0); 
  fill(255);
  smooth();
  textSize(16);
  //K=0.0001;////K=0; //K = 0.5;//K = 0.45;//K=1.4; //K=2.5;//K=3.5;//K=4.9976;
  K = 0.971635; //dieser Parameter der Map: Rotationszahl ist goldener Schnitt
  wx = width/2 ;
  hy = height/2 ;
  A=0; B=0;
  r=0; phi =0; R=0;
  text("K = "+K, 20, 20);
  n= 20000;  //n...Anzahl der Iterationen
  L =200; //L Zufallsstartpunkte
  l = 0; //zählt die Zufallspunkte
  M = 10000; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  AnzahlMFPunkte = 80000;//Anzahl der Punkte auf dem Vektor (dauert eine Weile!)
  AnzahlIterationen =30;
  aUNeu = aU; aONeu = aO;//Winkelbereich
  rUNeu = rU; rONeu = rO;//Bereich des Radius
  println("K = "+K,"aU = "+aUNeu,"aO = "+aONeu,"rU = "+rUNeu,"rO = "+rONeu);
 
  faktor =4;//0.25;//Zoomfaktor
 // faktorE = 100*faktor;//Zoomfaktor Mannigfaltigkeit
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  
  bild = createImage(width,height,RGB);
  strokeWeight(1);
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
     //zufällige Startpunkte  
     aH = random((float)aUNeu,(float)aONeu);    
     rH = random((float)rUNeu,(float)rONeu); 
     //rH = 2*PI/8;strokeWeight(2);  //um für einzelne rationale Drehzahlen die Punkte zu zeichnen
     rK = rH*100*faktor; 
     point((float)(rK*Math.cos(aH)+wx),(float)(hy-rK*Math.sin(aH)));    
     iteriere(aH,rH,n,K);     
     if(l<L){
      l++;  
     }
     if(l>=L && !trajektZeichnen){   
       zeichnen = false;        
       tint(255,20);//aktiviert:Bild wird teiltransparent, um die Trajektoerie besser zu sehen
     } 
      if(l>=L){
       zeichnen = false;        
       MFZeichnen();
     } 
   }  
 }
//Aus gegebenem Startpunkt (aH,rH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double aH, double rH, int N ,double K){  
  colorMode(HSB,256,256,256);  
  stroke(color(f%256,255,255)); 
  i=0;
  this.K =K;
  aAlt = aH; 
  rAlt = rH;
  n =   N;
  //int zaehlen = 0;//Zur Kontrolle, ob rK >=0
  while(i <=n){  
       rNeu = rAlt + K*Math.sin(aAlt); 
       aNeu = (aAlt + rNeu) % (2*PI);  
       rK = rNeu*100*faktor;
       if(rK <0) {rK = 0; }// println(rK);//Zur Kontrolle, ob rK >=0     
       point((float)(rK*Math.cos(aNeu)+wx),(float)(hy-rK*Math.sin(aNeu)));   
       aAlt = aNeu;
       rAlt = rNeu;
       i++; 
  }
   i=0;  f=f+10;  
}
/////////////////////////////////////////////////////////////////////
void MFZeichnen(){
   strokeWeight(1);
  
    
   float aEV = 0;
   float rEV =(float) 1/1000;
   //instabile Mannigfaltigkeit
   for(int i=0; i<AnzahlMFPunkte;i++){
     aVektor = (float)i*aEV/AnzahlMFPunkte;
     rVektor = (float)i*rEV/AnzahlMFPunkte;
     //println(aVektor,100*rVektor);
     //println(AnzahlMFPunkte,i*rEV);     
     punkte0.add(new PVector(aVektor,rVektor));
     point(wx+100*punkte0.get(i).y*cos(punkte0.get(i).x),hy-100*punkte0.get(i).y*sin(punkte0.get(i).x));
    //println(wx+100*punkte0.get(i).y*cos(punkte0.get(i).x),hy-100*punkte0.get(i).y*sin(punkte0.get(i).x));
   }
   for(int j=0; j<AnzahlIterationen;j++){ 
     punkte1.clear();
     for(int i=0; i<AnzahlMFPunkte;i++){  
       rE= punkte0.get(i).y + K*sin(punkte0.get(i).x);
       aE= (punkte0.get(i).x + rE) % (2*PI);
       while(aE<0) aE = aE + 2*PI;
       while(aE>2*PI) aE = aE - 2*PI;
       if(rE <0) {rE = 0; }
       rK = rE*100*faktor;
       punkte1.add(new PVector((float)aE,(float)rE));
       stroke(255);
       point((float)(rK*Math.cos(aE)+wx),(float)(hy-rK*Math.sin(aE)));   
      // println((float)(faktorE*rE*Math.cos(aE)+wx),(float)(hy-faktorE*rE*Math.sin(aE)));
       punkte0.set(i,punkte1.get(i));
       
     }
    //stabile Mannigfaltigkeitl
    }
    for(int i=0; i<AnzahlMFPunkte;i++){
     aVektor = (float)i*aEV/AnzahlMFPunkte;
     rVektor = (float)i*rEV/AnzahlMFPunkte;
     //println(aVektor,100*rVektor);
     //println(AnzahlMFPunkte,i*rEV);     
     punkte2.add(new PVector(aVektor,rVektor));
    // point(wx+100*punkte0.get(i).y*cos(punkte0.get(i).x),hy-100*punkte0.get(i).y*sin(punkte0.get(i).x));
    //println(wx+100*punkte0.get(i).y*cos(punkte0.get(i).x),hy-100*punkte0.get(i).y*sin(punkte0.get(i).x));
   }
   for(int j=0; j<AnzahlIterationen;j++){ 
     punkte3.clear();
     for(int i=0; i<AnzahlMFPunkte;i++){  
       aE= (punkte2.get(i).x - punkte2.get(i).y) % (2*PI);
       rE= punkte2.get(i).y - K*Math.sin(aE);
      
       while(aE<0) aE = aE + 2*PI;
       while(aE>2*PI) aE = aE - 2*PI;
       if(rE <0) {rE = 0; }
       rK = rE*100*faktor;
       punkte3.add(new PVector((float)aE,(float)rE));
       stroke(40,255,255);
       point((float)(rK*Math.cos(aE)+wx),(float)(hy-rK*Math.sin(aE)));   
      // println((float)(faktorE*rE*Math.cos(aE)+wx),(float)(hy-faktorE*rE*Math.sin(aE)));
       punkte2.set(i,punkte3.get(i));
       
     }
   }  
}
/////////////////////////////////////////////////////////////////////
void punkteLoeschen(){
    punkte0.clear();
    punkte1.clear();
    punkte2.clear();
    punkte3.clear();
}

void mousePressed() { 
  //////////////////////////////////////////////////////////
  //Trajektorie zeichnen
  if(mouseButton == LEFT){
      trajektZeichnen = true;
     // f = f +19;
      if(!schonTransparent){
        image(bild,0,0);  
        schonTransparent = true;
      }   
      i=0;n = 10000;strokeWeight(1);
      //strokeWeight(4);//aktivieren, wenn erster Punkt markiert werden soll
      point(mouseX,mouseY);
      strokeWeight(1);
      A = (mouseX-wx)/100/faktor;
      B = (hy-mouseY)/100/faktor;
      
      
      if((A>= 0 && B>= 0)||(A<= 0 && B>= 0))  {aH =   PI/2-Math.atan(A/B);  rH = B/Math.cos(Math.atan(A/B));}//println(aH,rH);
      if((A<= 0 && B<= 0)||(A>= 0 && B<= 0))  {aH = 3*PI/2-Math.atan(A/B);  rH =-B/Math.cos(Math.atan(A/B));}//println(aH,rH);} 
      l=L-1; 
      zeichnen = true;
      iteriere(aH,rH,n,K); 
      zeichnen = false;
      trajektZeichnen = false;
  }
  
}
/////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){//Vergrößern mit Faktor 2
    background(0);
    n=n+n/2;
    L=L+L/2;
    faktor = faktor*2;
    l = 0;
    punkteLoeschen();
    zeichnen = true;   
  }
  if (key == '-'){//Verkleinern mit Faktor 2
    background(0);
    punkte1.clear();
    punkte0.clear();
    faktor = faktor/2;
    l = 0;
    zeichnen = true;   
  }  
  if(key == 'r'){//Bild um 100 Pixel nach rechts verschieben
     background(0);
     punkteLoeschen();
     wx = wx +100;
     l = 0;
     zeichnen = true;     
  }
  if(key == 'l'){//Bild um 100 Pixel nach links verschieben
     background(0);
     punkteLoeschen();
     wx = wx -100;
     l = 0;
     zeichnen = true;     
  }
  if(key == 'u'){//Bild um 100 Pixel nach oben (up) verschieben
     background(0);
     punkteLoeschen();
     hy = hy -100;
     l = 0;
     zeichnen = true;     
  }
  if(key == 'd'){//Bild um 100 Pixel nach unten (down) verschieben
     background(0);
     punkteLoeschen();
     hy = hy +100;
     l = 0;
     zeichnen = true;     
  }
}
